#include "bsp.h"
#include <stdlib.h>
#include "mytime.h"

#define min(x,y) ((x)<(y))? x:y


void spmd_start();

char usage_str[] = "-s <array size>";
int *xs, size, sum;

int bsp_sum(int *xs, int nelem) {
  int *local_sums,i,j,result=0;

  for(j=0;j<nelem;j++) result += xs[j];

  bsp_push_reg(&result,sizeof(int));
  bsp_sync();

  local_sums = calloc(bsp_nprocs(),sizeof(int));
  if (local_sums==NULL)
    bsp_abort("{bsp_sum} no memory for %d int",bsp_nprocs());
  for(i=0;i<bsp_nprocs();i++)
    bsp_hpget(i,&result,0,&local_sums[i],sizeof(int));
  bsp_sync();

  result=0;
  for(i=0;i<bsp_nprocs();i++) result += local_sums[i];
  bsp_pop_reg(&result); 
  free(local_sums);
  return result;
}

void spmd_start() {
  int i,j;
	chrono t1,t2;
	double t;
  
  bsp_begin(bsp_nprocs());
    xs   = calloc(size,sizeof(int));
    for(i=0;i<size;i++) xs[i]=1;

		GETTIME(t1);
    sum = bsp_sum(xs,size);
		GETTIME(t2);

    for(i=0;i<bsp_nprocs();i++) {
      if (bsp_pid()==i) {
        printf("On %d Sum(",bsp_pid());
        printf(")=%d time spent = %lf\n",sum,DIFTIME(t2,t1));
      }
      fflush(stdout);
      bsp_sync();
    } 
  bsp_end();   
}

void main(int argc, char* argv[]) {
  int i,temp, command_line_opts=1;
  double trash;

  bsp_init(spmd_start,argc,argv);
  i=1;
  while (command_line_opts) {
    if (i >= argc) {
      command_line_opts = 0;
    } else if ( (strcmp(argv[i],"-s")==0) &&
                (sscanf(argv[i+1],"%d",&temp))) {
      size = temp/bsp_nprocs();
      i += 2;
    } else {
      bsp_abort("{%s}: unknown option \"%s\"\n\t%s\n",
                argv[0],argv[i],usage_str);
    }
  }
  if (bsp_nprocs()<1) bsp_abort("{%s} usage: %s",argv[0],usage_str);
  spmd_start();
  exit(0);
}

